package com.hfkj.dao;

import com.hfkj.entity.BsOrderChild;
import com.hfkj.entity.BsOrderChildExample.Criteria;
import com.hfkj.entity.BsOrderChildExample.Criterion;
import com.hfkj.entity.BsOrderChildExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class BsOrderChildSqlProvider {

    public String countByExample(BsOrderChildExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("bs_order_child");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(BsOrderChildExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("bs_order_child");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(BsOrderChild record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("bs_order_child");
        
        if (record.getOrderNo() != null) {
            sql.VALUES("order_no", "#{orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getChildOrderNo() != null) {
            sql.VALUES("child_order_no", "#{childOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getMerId() != null) {
            sql.VALUES("mer_id", "#{merId,jdbcType=BIGINT}");
        }
        
        if (record.getProductType() != null) {
            sql.VALUES("product_type", "#{productType,jdbcType=INTEGER}");
        }
        
        if (record.getProductId() != null) {
            sql.VALUES("product_id", "#{productId,jdbcType=BIGINT}");
        }
        
        if (record.getProductName() != null) {
            sql.VALUES("product_name", "#{productName,jdbcType=VARCHAR}");
        }
        
        if (record.getProductImg() != null) {
            sql.VALUES("product_img", "#{productImg,jdbcType=VARCHAR}");
        }
        
        if (record.getProductSpecId() != null) {
            sql.VALUES("product_spec_id", "#{productSpecId,jdbcType=BIGINT}");
        }
        
        if (record.getProductSpecName() != null) {
            sql.VALUES("product_spec_name", "#{productSpecName,jdbcType=VARCHAR}");
        }
        
        if (record.getProductPrice() != null) {
            sql.VALUES("product_price", "#{productPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getProductCount() != null) {
            sql.VALUES("product_count", "#{productCount,jdbcType=INTEGER}");
        }
        
        if (record.getProductTotalPrice() != null) {
            sql.VALUES("product_total_price", "#{productTotalPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getTotalDeductionPrice() != null) {
            sql.VALUES("total_deduction_price", "#{totalDeductionPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getCouponDiscountPrice() != null) {
            sql.VALUES("coupon_discount_price", "#{couponDiscountPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getIntegralDiscountPrice() != null) {
            sql.VALUES("integral_discount_price", "#{integralDiscountPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getProductActualPrice() != null) {
            sql.VALUES("product_actual_price", "#{productActualPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getSurplusRefundCount() != null) {
            sql.VALUES("surplus_refund_count", "#{surplusRefundCount,jdbcType=INTEGER}");
        }
        
        if (record.getSurplusRefundPrice() != null) {
            sql.VALUES("surplus_refund_price", "#{surplusRefundPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getSurplusRefundIntegral() != null) {
            sql.VALUES("surplus_refund_integral", "#{surplusRefundIntegral,jdbcType=BIGINT}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getSettleAccount() != null) {
            sql.VALUES("settle_account", "#{settleAccount,jdbcType=VARCHAR}");
        }
        
        if (record.getSettleAccountKey() != null) {
            sql.VALUES("settle_account_key", "#{settleAccountKey,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getFinishTime() != null) {
            sql.VALUES("finish_time", "#{finishTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        if (record.getChannelOrderNo() != null) {
            sql.VALUES("channel_order_no", "#{channelOrderNo,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(BsOrderChildExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("order_no");
        sql.SELECT("child_order_no");
        sql.SELECT("mer_id");
        sql.SELECT("product_type");
        sql.SELECT("product_id");
        sql.SELECT("product_name");
        sql.SELECT("product_img");
        sql.SELECT("product_spec_id");
        sql.SELECT("product_spec_name");
        sql.SELECT("product_price");
        sql.SELECT("product_count");
        sql.SELECT("product_total_price");
        sql.SELECT("total_deduction_price");
        sql.SELECT("coupon_discount_price");
        sql.SELECT("integral_discount_price");
        sql.SELECT("product_actual_price");
        sql.SELECT("surplus_refund_count");
        sql.SELECT("surplus_refund_price");
        sql.SELECT("surplus_refund_integral");
        sql.SELECT("`status`");
        sql.SELECT("settle_account");
        sql.SELECT("settle_account_key");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("finish_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.SELECT("channel_order_no");
        sql.FROM("bs_order_child");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        BsOrderChild record = (BsOrderChild) parameter.get("record");
        BsOrderChildExample example = (BsOrderChildExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("bs_order_child");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getOrderNo() != null) {
            sql.SET("order_no = #{record.orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getChildOrderNo() != null) {
            sql.SET("child_order_no = #{record.childOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getMerId() != null) {
            sql.SET("mer_id = #{record.merId,jdbcType=BIGINT}");
        }
        
        if (record.getProductType() != null) {
            sql.SET("product_type = #{record.productType,jdbcType=INTEGER}");
        }
        
        if (record.getProductId() != null) {
            sql.SET("product_id = #{record.productId,jdbcType=BIGINT}");
        }
        
        if (record.getProductName() != null) {
            sql.SET("product_name = #{record.productName,jdbcType=VARCHAR}");
        }
        
        if (record.getProductImg() != null) {
            sql.SET("product_img = #{record.productImg,jdbcType=VARCHAR}");
        }
        
        if (record.getProductSpecId() != null) {
            sql.SET("product_spec_id = #{record.productSpecId,jdbcType=BIGINT}");
        }
        
        if (record.getProductSpecName() != null) {
            sql.SET("product_spec_name = #{record.productSpecName,jdbcType=VARCHAR}");
        }
        
        if (record.getProductPrice() != null) {
            sql.SET("product_price = #{record.productPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getProductCount() != null) {
            sql.SET("product_count = #{record.productCount,jdbcType=INTEGER}");
        }
        
        if (record.getProductTotalPrice() != null) {
            sql.SET("product_total_price = #{record.productTotalPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getTotalDeductionPrice() != null) {
            sql.SET("total_deduction_price = #{record.totalDeductionPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getCouponDiscountPrice() != null) {
            sql.SET("coupon_discount_price = #{record.couponDiscountPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getIntegralDiscountPrice() != null) {
            sql.SET("integral_discount_price = #{record.integralDiscountPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getProductActualPrice() != null) {
            sql.SET("product_actual_price = #{record.productActualPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getSurplusRefundCount() != null) {
            sql.SET("surplus_refund_count = #{record.surplusRefundCount,jdbcType=INTEGER}");
        }
        
        if (record.getSurplusRefundPrice() != null) {
            sql.SET("surplus_refund_price = #{record.surplusRefundPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getSurplusRefundIntegral() != null) {
            sql.SET("surplus_refund_integral = #{record.surplusRefundIntegral,jdbcType=BIGINT}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getSettleAccount() != null) {
            sql.SET("settle_account = #{record.settleAccount,jdbcType=VARCHAR}");
        }
        
        if (record.getSettleAccountKey() != null) {
            sql.SET("settle_account_key = #{record.settleAccountKey,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getFinishTime() != null) {
            sql.SET("finish_time = #{record.finishTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        if (record.getChannelOrderNo() != null) {
            sql.SET("channel_order_no = #{record.channelOrderNo,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("bs_order_child");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("order_no = #{record.orderNo,jdbcType=VARCHAR}");
        sql.SET("child_order_no = #{record.childOrderNo,jdbcType=VARCHAR}");
        sql.SET("mer_id = #{record.merId,jdbcType=BIGINT}");
        sql.SET("product_type = #{record.productType,jdbcType=INTEGER}");
        sql.SET("product_id = #{record.productId,jdbcType=BIGINT}");
        sql.SET("product_name = #{record.productName,jdbcType=VARCHAR}");
        sql.SET("product_img = #{record.productImg,jdbcType=VARCHAR}");
        sql.SET("product_spec_id = #{record.productSpecId,jdbcType=BIGINT}");
        sql.SET("product_spec_name = #{record.productSpecName,jdbcType=VARCHAR}");
        sql.SET("product_price = #{record.productPrice,jdbcType=DECIMAL}");
        sql.SET("product_count = #{record.productCount,jdbcType=INTEGER}");
        sql.SET("product_total_price = #{record.productTotalPrice,jdbcType=DECIMAL}");
        sql.SET("total_deduction_price = #{record.totalDeductionPrice,jdbcType=DECIMAL}");
        sql.SET("coupon_discount_price = #{record.couponDiscountPrice,jdbcType=DECIMAL}");
        sql.SET("integral_discount_price = #{record.integralDiscountPrice,jdbcType=DECIMAL}");
        sql.SET("product_actual_price = #{record.productActualPrice,jdbcType=DECIMAL}");
        sql.SET("surplus_refund_count = #{record.surplusRefundCount,jdbcType=INTEGER}");
        sql.SET("surplus_refund_price = #{record.surplusRefundPrice,jdbcType=DECIMAL}");
        sql.SET("surplus_refund_integral = #{record.surplusRefundIntegral,jdbcType=BIGINT}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("settle_account = #{record.settleAccount,jdbcType=VARCHAR}");
        sql.SET("settle_account_key = #{record.settleAccountKey,jdbcType=VARCHAR}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("finish_time = #{record.finishTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        sql.SET("channel_order_no = #{record.channelOrderNo,jdbcType=VARCHAR}");
        
        BsOrderChildExample example = (BsOrderChildExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(BsOrderChild record) {
        SQL sql = new SQL();
        sql.UPDATE("bs_order_child");
        
        if (record.getOrderNo() != null) {
            sql.SET("order_no = #{orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getChildOrderNo() != null) {
            sql.SET("child_order_no = #{childOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getMerId() != null) {
            sql.SET("mer_id = #{merId,jdbcType=BIGINT}");
        }
        
        if (record.getProductType() != null) {
            sql.SET("product_type = #{productType,jdbcType=INTEGER}");
        }
        
        if (record.getProductId() != null) {
            sql.SET("product_id = #{productId,jdbcType=BIGINT}");
        }
        
        if (record.getProductName() != null) {
            sql.SET("product_name = #{productName,jdbcType=VARCHAR}");
        }
        
        if (record.getProductImg() != null) {
            sql.SET("product_img = #{productImg,jdbcType=VARCHAR}");
        }
        
        if (record.getProductSpecId() != null) {
            sql.SET("product_spec_id = #{productSpecId,jdbcType=BIGINT}");
        }
        
        if (record.getProductSpecName() != null) {
            sql.SET("product_spec_name = #{productSpecName,jdbcType=VARCHAR}");
        }
        
        if (record.getProductPrice() != null) {
            sql.SET("product_price = #{productPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getProductCount() != null) {
            sql.SET("product_count = #{productCount,jdbcType=INTEGER}");
        }
        
        if (record.getProductTotalPrice() != null) {
            sql.SET("product_total_price = #{productTotalPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getTotalDeductionPrice() != null) {
            sql.SET("total_deduction_price = #{totalDeductionPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getCouponDiscountPrice() != null) {
            sql.SET("coupon_discount_price = #{couponDiscountPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getIntegralDiscountPrice() != null) {
            sql.SET("integral_discount_price = #{integralDiscountPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getProductActualPrice() != null) {
            sql.SET("product_actual_price = #{productActualPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getSurplusRefundCount() != null) {
            sql.SET("surplus_refund_count = #{surplusRefundCount,jdbcType=INTEGER}");
        }
        
        if (record.getSurplusRefundPrice() != null) {
            sql.SET("surplus_refund_price = #{surplusRefundPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getSurplusRefundIntegral() != null) {
            sql.SET("surplus_refund_integral = #{surplusRefundIntegral,jdbcType=BIGINT}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getSettleAccount() != null) {
            sql.SET("settle_account = #{settleAccount,jdbcType=VARCHAR}");
        }
        
        if (record.getSettleAccountKey() != null) {
            sql.SET("settle_account_key = #{settleAccountKey,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getFinishTime() != null) {
            sql.SET("finish_time = #{finishTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        if (record.getChannelOrderNo() != null) {
            sql.SET("channel_order_no = #{channelOrderNo,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, BsOrderChildExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}